<?PHP

/*
Code by Kris Merckx - 2018
Part & port of Crowl STDIO.PHP
MIT-license
Do not remove this copyright notice
*/

define("HOST",$servername);
define("USER",$username);
define("PWD",$password);
define("DATABASE",$dbname);

class Database {
	private $_connection;
	private static $_instance; //The single instance
	private $_host = HOST;
	private $_username = USER;
	private $_password = PWD;
	private $_database = DATABASE;

	public static function OPEN() {
		if(!self::$_instance) { // If no instance then make one
			self::$_instance = new self();
		}
		return self::$_instance;
	}

    private function __construct() {
        $con = new mysqli($this->_host, $this->_username, 
			$this->_password, $this->_database);
        //$con->set_charset("utf8");
        
		$this->_connection = $con;
        //$this->_connection->set_charset("utf8")
		// Error handling
		if(mysqli_connect_error()) {
			trigger_error("Oohoo. Crowl can't find the database: " . mysql_connect_error(), E_USER_ERROR);
		}
	}
    
	// Magic method clone is empty to prevent duplication of connection
	private function __clone() { }
	// Get mysqli connection
	public function CONNECT() {
		return $this->_connection;
	}
    
    public function CRUDQ(){
        return $this->_connection;
    }
    
    public function Q($sql){
        //geen drop, delete, update, insert 
        $sqlC = strtolower($sql);
        $D = strpos($sqlC,"delete");
        $I = strpos($sqlC, "insert");
        $DR = strpos($sqlC, "drop");
        $U = strpos($sqlC, "update");
        $A = strpos($sqlC, "alter");

        if($D > -1 || $I > -1 || $DR > -1 || $U > -1  || $A > -1){
            echo "mag niet uitgevoerd worden";
        }else{
            //$this->_connection->query('SET NAMES utf8');
            $result = $this->_connection->query($sql);
            return $result;
        } 
    }
    
    public function C($sql){
        $result = $this->_connection->query($sql);
        return $result->num_rows;
    }
    
    public function CN($table){
        $sql = "SHOW COLUMNS FROM $table";
        $result = $this->_connection->query($sql);
        
        $CNS=array();
        while($row = mysqli_fetch_array($result)){
            array_push($CNS,$row['Field']);
        }
        return $CNS;
    }
    
    public function __destruct() {
        $this->_connection->close();
    }

}
class JOURNALIST{
    private $number = 0;
    private $articles;
    private $db;
    
    public function __construct($sql) {
        $this->db = Database::OPEN();
        $this->number = $this->db->C($sql);
        $this->articles = $this->db->Q($sql);
	}
    
    public function COUNT(){
        echo $this->number;
    }
    
    public function __destruct() {
        $this->db = null;
    }

    public function PASTE($template){
        while($row = mysqli_fetch_array($this->articles)){
            $topaste = $template;
            $content = $row["content"];
            $content = str_replace("images/", "cms/images/", $content);
            $topaste = str_replace("<ct:title/>", $row["title"], $topaste);
            $topaste = str_replace("<ct:content/>", $content, $topaste);
            $topaste = str_replace("<ct:articledate/>", $row["articledate"], $topaste);
            $topaste = str_replace("<ct:id/>", $row["id"], $topaste);
            $topaste = str_replace("<ct:cover/>", $row["cover"], $topaste);
            echo $topaste;
        }
    }
        
    
}
class SEARCH{
    
    public function __construct($q, $template) {
        if(isset($_GET[$q])){
            $filter = $_GET[$q];
            $j = new JOURNALIST("select * from articles where title like '%$filter%' or content like '%$filter%'");   
            $j->PASTE($template);
        }else{
            echo "Geen zoekopdracht verzonden";
        }
	}
}

class OPENGROUP{
    private $articles;
    private $db;
    private $number;
    private $template;
    
    public function __construct($id) {
       $this->db = Database::OPEN();
       $sql = "select * from grouparticles where groupid=$id";
       $this->number = $this->db->C($sql);
       $this->articles = $this->db->Q($sql); 
       
	}
    
    public function TOTAL(){
        return $this->number;
    }
    
    public function PASTE($template){
        $this->template = $template;
        $grouparts = array();
        $ids = "";
        $komma = "";
        if($this->number > 0){
            while($row = $this->articles->fetch_assoc()) {
                array_push($grouparts,$row["articleid"]);
                $ids = $ids . $komma .  $row["articleid"];
                $komma = ",";
            }
        }
        $sql = "select * from articles where id in ($ids) order by title ASC";
        $j = new JOURNALIST($sql);   
        $j->PASTE($this->template);
        //open alles van articles where in list
    }
    
}

class OPENARTICLE{
    public function __construct($q, $template) {
        if(isset($_GET[$q])){
            $filter = $_GET[$q];
            $j = new JOURNALIST("select * from articles where id=$filter");   
            $j->PASTE($template);
        }else{
            echo "Geen zoekopdracht verzonden";
        }
	}
}

?>
